/*****************************************************************************
*
* Description: IDC Tracer serive functions
* Author: pva <pva_co@ukr.net>
*
* Copyright (c) 2005, pva All rights reserved.
*
* $Log$
*****************************************************************************/
#include <idc.idc>

//
// Log current string to file
//
#define	LogCmd()							\
	if( !silent_ )	fprintf(flog, "\t%s\n", sCurrentString);	\
	else		fprintf(flog, ";\t\t%s\n", sCurrentString)

//
// Log any string to file
//
#define	Log(s)		fprintf(flog, "%s", (s));

//
// Assign value to register
//
#define num2reg(op, item)					\
	if( strstr((op), "eax") == 0 ) r_eax = (item);	else	\
	if( strstr((op), "ebx") == 0 ) r_ebx = (item);	else	\
	if( strstr((op), "ecx") == 0 ) r_ecx = (item);	else	\
	if( strstr((op), "edx") == 0 ) r_edx = (item);	else	\
	if( strstr((op), "esi") == 0 ) r_esi = (item);	else	\
	if( strstr((op), "edi") == 0 ) r_edi = (item);	else	\
	if( strstr((op), "ebp") == 0 ) r_ebp = (item)

//
// Return register value
//
#define	reg2num(op, item)					\
	if( strstr((op), "eax") == 0 ) item = r_eax;	else	\
	if( strstr((op), "ebx") == 0 ) item = r_ebx;	else	\
	if( strstr((op), "ecx") == 0 ) item = r_ecx;	else	\
	if( strstr((op), "edx") == 0 ) item = r_edx;	else	\
	if( strstr((op), "esi") == 0 ) item = r_esi;	else	\
	if( strstr((op), "edi") == 0 ) item = r_edi;	else	\
	if( strstr((op), "ebp") == 0 ) item = r_ebp

//
// Operation
//
#define reg_num(op, item, b)						\
	if( strstr((op), "eax") == 0 ) r_eax = r_eax b (item);	else	\
	if( strstr((op), "ebx") == 0 ) r_ebx = r_ebx b (item);	else	\
	if( strstr((op), "ecx") == 0 ) r_ecx = r_ecx b (item);	else	\
	if( strstr((op), "edx") == 0 ) r_edx = r_edx b (item);	else	\
	if( strstr((op), "esi") == 0 ) r_esi = r_esi b (item);	else	\
	if( strstr((op), "edi") == 0 ) r_edi = r_edi b (item);	else	\
	if( strstr((op), "ebp") == 0 ) r_ebp = r_ebp b (item)

//
// Helper: Operand -> Value resolver
// Return: 0 on error <- need replace ?
//
#define	op2num(op, item, idx)						\
	item	= makeNumber(op);					\
	if( (item == 0) && (GetOpType(ScreenEA(), (idx)) == 1) )	\
	{								\
		reg2num(op, item);					\
	}


//
// Determine next address to analyse
//
static	getNextAddr(lEA)
{
	auto	result;

	result	= BADADDR;
	if( (lEA != BADADDR) && isCode(GetFlags(lEA)) )
	{
		result	= ItemEnd(lEA);
	}
	return result;
}

//
// Dec or Hex to Integer
//
static makeNumber(x)
{
	auto	result;

	result	= 0;
	if( atol(ltoa(x, 10)) == x )
	{
		result	= x;
	}
	else
	if( strlen(ltoa(xtol(x), 16)) == strlen(x) )
	{
		result	= xtol(x);
	}
	else
	if( strlen(ltoa(atol(x), 10)) == strlen(x) )
	{
		result	= atol(x);
	}
	
//	Message("[DEBUG]: makeNumber(x) => %08x\n", result);
	return result;
}

//
// Integer, Symbolic or $ address representation -> integer
//
static makeAddr(pEA)
{
	auto	result, addr;

	result	= BADADDR;
	addr	= makeNumber(pEA);
	if( addr != 0 )
	{
		result	= addr;
	}
	else
	if( LocByName(pEA) != BADADDR )
	{
		result	= LocByName(pEA);
	}
	else
	{
		if( strstr(pEA, "near") != -1 )
		{
			addr = substr(pEA, strlen("near ptr "), -1);
			result = LocByName(addr);
		}
		else
		if( strstr(pEA, "$") != -1 )
		{
			addr = makeNumber(substr(pEA, strlen("$+"), -1));
			if( addr != 0 )
				result = ScreenEA() + addr;
		}
	}
//	Message("[DEBUG]: makeAddr() => %08x\n", result);
	return result;
}

//
// Return operand integer value or mnemonic, depends on instruction
//
static makeOperand(lEA, lOp)
{
	auto	result, i;

	i	= GetOpType(lEA, lOp);
	result	= 0;

	if( (i > 4) && (i < 6) )
	{
		result	= GetOperandValue(lEA, lOp);
//		Message("[DEBUG]: makeOperand(%08x, %d) => %d::%08x\n", lEA, lOp, i, result);
	}
	else
	{
		result	= GetOpnd(lEA, lOp);
//		Message("[DEBUG]: makeOperand(%08x, %d) => %d::%s\n", lEA, lOp, i, result);
	}


	return result;
}
